<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\Session\Session;
use Teknisa\MAN\Utilities\Util;
use Teknisa\MAN\Services\NovoCodigo;


class AprovacaoPrevisaoEstoque extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceName = 'vnd06300_aprovacao_previsaodeconsumo';
    protected $environment;
    protected $crudService;
    protected $novoCodigo;
    protected $AprovacaoPrevisaoEstoque;
    
    protected $parameterBagPrevisaoGrid = array('NRORG', 'DTPREVINI', 'DTPREVFIN', 'CDLOJA', 'CDFILIAL', 'TCDLOJA');
    
    public function __construct($crudService, $environment, $AprovacaoPrevisaoEstoque, Util $util, NovoCodigo $novoCodigo) {
        $this->crudService =$crudService;
        $this->environment = $environment;
        $this->aprovacaoPrevisaoEstoque = $AprovacaoPrevisaoEstoque;
        $this->util                     = $util;
        $this->novoCodigo               = $novoCodigo;
    }
    
    public function findProd(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd06300_aprovacao_previsaodeconsumo_produtos';
        parent::find($request,$response);
    }
    
    public function findLog(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd06300_aprovacaoprevisaodeconsumo_tabLogAprov';
        parent::find($request,$response);
    }
    
     public function save(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows()[0];
        return $this->aprovacaoPrevisaoEstoque->updateLog($rows);
    }
    
    public function aprovaPrevisao(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows()[0];
        $senha = md5($rows["SENHA"]);
        $contador = 0;
        $IDAPROVPREVCONS = $rows['IDAPROVPREVCONS'];
        $senhaBD = $this->aprovacaoPrevisaoEstoque->getSenhaOperador($rows);
        if($senha == $senhaBD){
            $adqPrevisaoPDVLim = $this->aprovacaoPrevisaoEstoque->adqPrevisaoPDVLim($rows);
            $adqCalePrevConsPDV = $this->aprovacaoPrevisaoEstoque->adqCalePrevConsPDV($rows, $adqPrevisaoPDVLim);
            foreach($rows['PRODUTOS'] as $produto){
                
                $dtCalePrevConsPDV = explode(' ', $adqCalePrevConsPDV['DTLIMAPROCONPDV'])[0];
                $DTATUAL         = self::returnDataYMD($adqCalePrevConsPDV['DTATUAL']);
                $DTLIMAPROCONPDV = self::returnDataYMD($adqCalePrevConsPDV['DTLIMAPROCONPDV']);
                
                if($adqCalePrevConsPDV['DTLIMAPROCONPDV'] == null || $DTLIMAPROCONPDV->format('Y-m-d') > $DTATUAL->format('Y-m-d')){
                    
                    $this->aprovacaoPrevisaoEstoque->acmPrevConsPDV($rows, $produto, $IDAPROVPREVCONS);
                    $this->aprovacaoPrevisaoEstoque->writeLog($rows, $produto, $IDAPROVPREVCONS);
                } else {
                    $contador++;
                }
            }
            
            if($contador > 0){
                if(count($rows['PRODUTOS']) == $contador){
                    $response->addMessage(new Message("Previsão fora da data Limite de aprovação!", Message::TYPE_WARNING));
                } else {
                    $response->addNotification(new Notification("Existem {$contador} previsões fora da data Limite de aprovação", Notification::TYPE_ALERT)); 
                }
            }
            if(count($rows['PRODUTOS']) != $contador){
                $response->addNotification(new Notification("Alteração realizada com sucesso!", Notification::TYPE_SUCCESS));
            }
        } else {
            $response->addMessage(new Message("Senha Incorreta!", Message::TYPE_WARNING));
            return $response;
        }
    }
    
    private function returnDataYMD ($date){
         return new \DateTime(date("Y-m-d", strtotime(str_replace("/", "-", $date))));
    }
    

}