<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class RelInconsistenciasSincronizacaoPedidosService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function fetchReport($conditions){
	    if(array_key_exists('CDFILIAL', $conditions)){
            $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            $conditions['TCDFILIAL'] = NULL;
        } else{
            $conditions['CDFILIAL'] = NULL;
            $conditions['TCDFILIAL'] = 'T';
        }
	    $params = array(  
	        ':CDFILIAL'       =>  $conditions['CDFILIAL'],
            ':TCDFILIAL'      =>  $conditions['TCDFILIAL'],
	        ':DTINI'          => $conditions['DTHRABERMESA'][0],   
	        ':DTFIN'          => $conditions['DTHRABERMESA'][1]
	    );
	    return $this->entityManager->getConnection()->fetchAll(self::INCONSISTENCIAS_SINCRONIZACAO_PEDIDOS_QRY, $params);
	}
	
const INCONSISTENCIAS_SINCRONIZACAO_PEDIDOS_QRY = "
     SELECT (F.CDFILIAL || '-' || F.NMFILIAL) AS LABELFILIAL, L.CDFILIAL, L.CDLOJA, L.NRVENDARESTAUX, L.DTHRABERMESA, L.DSLOG, L.DSLOGMSG 
        FROM LOGSINCDLV L
        INNER JOIN FILIAL F
        ON F.CDFILIAL = L.CDFILIAL
        AND F.IDATIVO = L.IDATIVO
        WHERE ((INSTR(:CDFILIAL, L.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
        AND L.DTHRABERMESA BETWEEN TO_DATE(:DTINI, 'DD/MM/YYYY') AND TO_DATE(:DTFIN, 'DD/MM/YYYY')
        ORDER BY L.CDFILIAL, L.DTHRABERMESA
    ";
}